
/**
 * A class to describe a point on a cartesian geometrical grid.
 * 
 * @author J. David Fleig 
 * @version 1.0
 */
public class Point
{
    private int x; //Location of the point in the x direction
    private int y; //Location of the point in the y direction

    /**
     * Default Constructor for objects of class Point
     */
    public Point()
    {
        // initialise instance variables
        x = 0;
        y = 0;
    }
    
    /**
     * Constructor for objects of class Point
     */
    public Point(int x, int y)
    {
        // initialise instance variables
        this.x = x;
        this.y = y;
    }


    /**
     * Mutator method for x
     * 
     * @param  x  The new x location
     */
    public void shiftX(int x)
    {
        this.x += x;
    }
    
   /**
     * Mutator method for y
     * 
     * @param  y  The new y location
     */
    public void shiftY(int y)
    {
        this.y += y;
    }
    
    /**
     * Accessor method for x
     * 
     * @return     x
     */
    public int getX()
    {
        return x;
    }
    
   /**
     * Accessor method for y
     * 
     * @return     y
     */
    public int getY()
    {
        return y;
    }
    
   /**
     * toString method for converting this object to a string form
     * 
     * @return     (x,y)
     */
    public String toString()
    {
        return "(" + x + "," + y + ")";
    }
}
