
/**
 * Simple Calculator
 * 
 * @author J. David Fleig 
 * @version 1.0
 */
public class WorkingCalculator
{
    private double total;
    private char operation;
    
    /**
	 * Setup the special symbols being used
	 */
	private static final char SYM_TERMINAL = '#';
	private static final char SYM_SUBTRACTION = '-';
	private static final char SYM_ADDITION = '+';
	private static final char SYM_DIVISION = '/';
	private static final char SYM_MULTIPLICATION = '*';
	private static final char SYM_LEFT_PAREN = '(';
	private static final char SYM_RIGHT_PAREN = ')';
	private static final char SYM_SPACE = ' ';
	private static final char SYM_TAB = '\t';
	private static final char SYM_NEWLINE = '\n';
	private static final char SYM_EQUALS = '=';
	private static final char SYM_NEGATION = '`';
	private static final char SYM_NULL = '|';

    /**
     * Constructor for objects of class WorkingCalculator
     */
    public WorkingCalculator()
    {
        total = 0.0;
        operation = SYM_NULL;
    }
    /**
     * Enters a number into the calculator. If no operation, then that is the current working value, otherwise do
     * calcuation and update
     */
    public void enter(double val)
    {
        switch (operation)
        {
            case SYM_NULL:
                total = val;
                break;
            case SYM_ADDITION:
                total += val;
                break;
            case SYM_SUBTRACTION:
                total -= val;
                break;
            case SYM_MULTIPLICATION:
                total *= val;
                break;
            case SYM_DIVISION:
                total /= val;
                break;
            default:
                break;
        }
    }

   /**
     * Set mode to addition
     * 
     */
    public void add()
    {
        operation = SYM_ADDITION;
    }

   /**
     * Set mode to subtraction
     */
    public void subtract()
    {
         operation = SYM_SUBTRACTION;
    }
    
     /**
      * Set mode to multiplication
     */
    public void multiply()
    {
         operation = SYM_MULTIPLICATION;
    }
    
     /**
     * set mode to division
     */
    public void divide()
    {
        operation = SYM_DIVISION;
    }
    
    /**
     * Resets calculator
     */
    public void clear()
    {
        operation = SYM_NULL;
        total = 0.0;
    }
    
    /**
     * Retrieve current calculator value
     */
    public double equals()
    {
        return total;
    }
}
