import java.util.Scanner;
import java.util.Vector;

/**
 * Write a description of class TaxiSimulator here.
 * 
 * @author J. David Fleig
 * @version July 2005
 */
public class TaxiSimulator
{
    protected Scanner sc;
    protected TaxiDispatch td;
    protected char cityMap[][];
    /**
     * Constructor for objects of class TaxiSimulator
     */
    public TaxiSimulator()
    {
        sc = new Scanner(System.in);
        td = new TaxiDispatch();
        cityMap = new char[20][20];
        setupMap();
    }

    protected void setupMap()
    {
        for (int i=0; i < 20 ; i++)
        {
         for (int j=0; j < 20 ; j++)
         {
             cityMap[i][j] = '.';
         }
        }
        
    }
    
    public void displayMenu()
    {
        System.out.println("***************");
        System.out.println("1. Display City Map");
        System.out.println("2. Request a Taxi");
        System.out.println("3. Advanced time by a minute");
        System.out.println("4. Quit");
    }
    
    public void displayMap()
    {
        setupMap();
        TaxiGarage garage = td.getGarage();
        int garageX = garage.getGarageLocationX();
        int garageY = garage.getGarageLocationY();
        cityMap[garageX][garageY] = 'G';
        
        Vector tService = td.getTaxisInService();
        for (int i=0; i < tService.size() ; i++)
        {
            TaxiCab cab = (TaxiCab) tService.elementAt(i);
            int cabX = cab.getCurrentLocationX();
            int cabY = cab.getCurrentLocationY();
            cityMap[cabX][cabY] = 'T';
            //See if passanger has been picked up, if not. display passenger as well
            if ( ! cab.hasPassenger() )
            {
              int passengerX = cab.getPickupLocationX();
              int passengerY = cab.getPickupLocationY();
              cityMap[passengerX][passengerY] = 'P';
            }
            else
            {
              int passengerX = cab.getDestinationLocationX();
              int passengerY = cab.getDestinationLocationY();
              cityMap[passengerX][passengerY] = 'D';
            }
        }
        
        Vector tWaiting = td.getTaxisWaiting();
        for (int i=0; i < tWaiting.size() ; i++)
        {
            TaxiCab cab = (TaxiCab) tWaiting.elementAt(i);
            int cabX = cab.getCurrentLocationX();
            int cabY = cab.getCurrentLocationY();
            cityMap[cabX][cabY] = 'T';
            //See if passanger has been picked up, if not. display passenger as well
           
        }
     
         for (int i=0; i < cityMap.length ; i++)
        {
         for (int j=0; j < cityMap[i].length ; j++)
         {
             System.out.print(cityMap[i][j]);
         }
         System.out.println();
        }
    }
    
    public void requestTaxi()
    {
        System.out.print("What is the pickup location (x then y):");
        int x = sc.nextInt();
        int y = sc.nextInt();
        System.out.print("What is the drop off location (x then y):");
        int dX = sc.nextInt();
        int dY = sc.nextInt();
        try
        {
            td.requestTaxi(x,y,dX,dY);
        }
        catch(Exception e)
        {
            System.out.println("I'm sorry, there are no taxis available at this time.");
        }
    }
    
    public void advanceTime()
    {
        td.advanceTime(1);
    }
    
    public void run()
    {
        while(true)
        {
            displayMenu();
            System.out.print("Selection:");
            int choice = sc.nextInt();
            if (choice<1 || choice> 4)
            {
                System.out.println("That is not a valid choice, please try again!");
                continue;
            }
            
            if (choice==1)
             displayMap();
            else if (choice==2)
             requestTaxi();
            else if (choice==3)
             advanceTime();
            else if (choice==4)
             break;
        }
    }
    
    public static void main(String args[])
    {
        TaxiSimulator ts = new TaxiSimulator();
        ts.run();
    }
    
}
