
/**
 * Searches an array using linear search
 * 
 * @author Todd A. Whittaker
 * @version July 2005
 */
public class LinearSearcher implements Searcher
{
    /**
     * Searches a subset of an array for the value between the
     * given left and right indices.
     * @param array the array to search
     * @param value the target value to find
     * @left the leftmost index (inclusive) to consider in the search
     * @right the rightmost index (exclusive) to consider in the search
     * @return the index (left <= index < right) where the element was
     * found, or a negative number when not found.
     */
    public int search(int[] array, int target, int left, int right)
    {
        for (int i=left; i<right; ++i)
        {
            ++opCount; // number of comparisons
            if (array[i] == target)
            {
                return i;
            }
        }
        return -right;
    }
    
    /**
     * Extract the number of primitive operations this object has done.
     * @return the count of operations performed
     */
    public int getOperationCount()
    {
        return opCount;
    }
    
    /**
     * Reset the operation count to zero.
     */
    public void resetOperationCount()
    {
        opCount = 0;
    }
    
    private int opCount = 0;
}
