

/**
 * The test class LinearSearcherTest.
 *
 * @author  Todd A. Whittaker
 * @version July 2005
 */
public class LinearSearcherTest extends junit.framework.TestCase
{
    private LinearSearcher searcher;
    private static final int MAXLEN = 1000;
    private int[] arr;
    
    /**
     * Default constructor for test class LinearSearcherTest
     */
    public LinearSearcherTest()
    {
        searcher = new LinearSearcher();
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
        arr = ArrayUtilities.createRandomIntArray(MAXLEN);
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }
    
    public void testAllGoodSearches()
    {
        for (int i=0; i<arr.length; ++i)
        {
            assertEquals(i, searcher.search(arr, arr[i], 0, arr.length));
        }
    }
    
    public void testAllRandomGoodSearches()
    {
        int[] arrIndices = new int[arr.length];
        for (int i=0; i<arrIndices.length; ++i)
        {
            arrIndices[i] = i;
        }
        ArrayUtilities.shuffleArray(arrIndices);
        
        for (int i=0; i<arrIndices.length; ++i)
        {
            assertEquals(arrIndices[i], searcher.search(arr, arr[arrIndices[i]], 0, arr.length));
        }
    }
    
    public void testBadSearches()
    {
        for (int i=0; i<arr.length; ++i)
        {
            assertEquals(-arr.length, searcher.search(arr, arr[i]-1, 0, arr.length));
        }
        for (int i=0; i<arr.length; ++i)
        {
            assertEquals(-arr.length, searcher.search(arr, arr[i]+1, 0, arr.length));
        }
    }
}
