
/**
 * A class that times the execution of various searching algorithms
 * 
 * @author Todd A. Whittaker
 * @version July 2003
 */
public class SearchTimer
{
    private StopWatch timer;
    
    /**
     * Builds a SortTimer
     */
    public SearchTimer()
    {
        this.timer = new StopWatch();
    }
    
    /**
     * Times how long it takes to sort the array the given number of times
     * using the provided sorter object.  The input array is not altered
     * (i.e. it remains unsorted).
     * @param sorter what to use for sorting
     * @param arr the array to sort
     * @param numTimes how many times to sort the data
     * @return the elapsed time for the execution, in milliseconds
     */
    public long timeSearch(Searcher searcher, int[] arr, int target, int numTimes)
    {
        for (int i=0; i<numTimes; ++i)
        {
            timer.start();
            searcher.search(arr, target, 0, arr.length);
            timer.stop();
        }
        return timer.getElapsedTime();
    }
}
