import java.util.Arrays;

/**
 * The test class SearchTimerTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class SearchTimerTest extends junit.framework.TestCase
{
    private SearchTimer timer;
    private int[] originalData;
    private int[] dataToSearch;
    private static final int MAXLENGTH = 10000;
    
    /**
     * Default constructor for test class SearchTimerTest
     */
    public SearchTimerTest()
    {
        timer = new SearchTimer();
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
        originalData = ArrayUtilities.createRandomIntArray(MAXLENGTH);
        dataToSearch = new int[originalData.length];
        System.arraycopy(originalData, 0, dataToSearch, 0, originalData.length);
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }
       
    public void testSearchTimer()
    {
        long elapsed = timer.timeSearch(new DoNothingSearcher(), dataToSearch, -1, 1000);
        assertTrue(elapsed > 0L);
        verifyUnchanged(originalData, dataToSearch, 0, originalData.length);
    }
    
    private class DoNothingSearcher implements Searcher
    {
        public int search(int[] arr, int value, int left, int right)
        {
            for (int i=0; i<arr.length; ++i)
            {
                arr[i] = arr[i] - 1;
            }
            for (int i=0; i<arr.length; ++i)
            {
                arr[i] = arr[i] + 1;
            }
            return -1;
        }
    }
    
    /**
     * Checks that the subset of two arrays are equal.
     * @param firstArray the first array to test
     * @param secondArray the second array to test
     * @param left the left bound to begin checking
     * @param right the right bound to end checking (not inclusive)
     */
    private static void verifyUnchanged(int[] firstArray, int[] secondArray, int left, int right)
    {
        for (int i=left; i<right; ++i)
        {
            assertEquals("Mismatch at index " + i, firstArray[i], secondArray[i]);
        }
    }
}
