
/**
 * Anything that can search an integer array for a target value between
 * left and right indices
 * 
 * @author Todd A. Whittaker
 * @version July 2005
 */

public interface Searcher
{
    /**
     * Searches a subset of an array for the value between the
     * given left and right indices.
     * @param array the array to search
     * @param value the target value to find
     * @left the leftmost index (inclusive) to consider in the search
     * @right the rightmost index (exclusive) to consider in the search
     * @return the index (left <= index < right) where the element was
     * found, or a negative number when not found.
     */
    int search(int[] array, int value, int left, int right);
}
