
/**
 * Sort an array of integers using bubble sort
 * 
 * @author Todd A. Whittaker
 * @version July 2003
 */
public class BubbleSorter implements Sorter
{
	/**
	 * Sort an array between left and right indices using bubble sort
	 * @param arr the array to sort
	 * @param left the left index for sorting
	 * @param right the right index for sorting (exclusive)
	 * @return the sorted array
	 */
	public int[] sort(int arr[], int left, int right)
    {
        boolean didSwap = true;
        int last = right-1;
        int temp = 0;

        while (didSwap)
        {
            didSwap = false;
            for (int i=left; i<last; ++i)
            {
                if (arr[i] > arr[i+1])
                {
                    if (!didSwap)
                    {
                        didSwap = true;
                    }
                    temp = arr[i];
                    arr[i] = arr[i+1];
                    arr[i+1] = temp;
                    ++opCount; // number of swaps
                }
            }
            --last;
        }
        return arr;
    }
    
    
    /**
     * Extract the number of primitive operations this object has done.
     * @return the count of operations performed
     */
    public int getOperationCount()
    {
        return opCount;
    }
    
    /**
     * Reset the operation count to zero.
     */
    public void resetOperationCount()
    {
        opCount = 0;
    }
    
    private int opCount = 0;
}