
/**
 * Sort an array of integers using insertion sort
 * 
 * @author Todd A. Whittaker
 * @version July 2003
 */
public class InsertionSorter implements Sorter
{
    /**
     * Sort an array between left and right indices using insertion sort
     * @param arr the array to sort
     * @param left the left index for sorting
     * @param right the right index for sorting (exclusive)
     * @return the sorted array
     */
    public int[] sort(int arr[], int left, int right)
    {
        int i,j,val;
        for (i=left+1; i<right; ++i)
        {
            val = arr[i];
            for(j=i-1; j >= left && arr[j] > val; --j)
            {
                arr[j+1] = arr[j];
                ++opCount; // number of shifts
            }
            arr[j+1] = val;
        }
        return arr;
    }

    /**
     * Extract the number of primitive operations this object has done.
     * @return the count of operations performed
     */
    public int getOperationCount()
    {
        return opCount;
    }
    
    /**
     * Reset the operation count to zero.
     */
    public void resetOperationCount()
    {
        opCount = 0;
    }
    
    private int opCount = 0;
}
