
/**
 * Sort an array of integers using selection sort
 * 
 * @author Todd A. Whittaker
 * @version July 2003
 */
public class SelectionSorter implements Sorter
{
	/**
	 * Sort an array between left and right indices using selection sort
	 * @param arr the array to sort
	 * @param left the left index for sorting
	 * @param right the right index for sorting (exclusive)
	 * @return the sorted array
	 */
	public int[] sort(int arr[], int left, int right)
    {
        int i,j,min,temp;
        
        for (i=left; i<right; ++i)
        {
            min = i;
            for (j = i; j < right; ++j)
            {
                if (arr[min] > arr[j])
                {
                    min = j;
                }
                ++opCount; // number of comparisons
            }
            temp = arr[min];
            arr[min] = arr[i];
            arr[i] = temp;
        }
        return arr;
    }
    
    /**
     * Extract the number of primitive operations this object has done.
     * @return the count of operations performed
     */
    public int getOperationCount()
    {
        return opCount;
    }
    
    /**
     * Reset the operation count to zero.
     */
    public void resetOperationCount()
    {
        opCount = 0;
    }
    
    private int opCount = 0;
}
